/***************************************************************************
	This source code is part of the Cognachrome 2000 vision system.
	Copyright 1994, Anne Wright, anarch@mit.edu,
	                Randy Sargent, rsargent@mit.edu
	This copy is not to be distributed in any form
	and is to be used only with express permission of the author.
****************************************************************************/

#ifndef __frame__
#define __frame__

#define FRAME_STREAM 15

extern persistent hwidth;
extern persistent vheight;
extern persistent frameborder;
extern persistent row_spacing;
extern persistent top_margin;
extern int frame_initialized;

#define HSYNC_DET() asm volatile("
1:
	moveb @(16775697),d0
	btst #3,d0
 	jne 1b
	moveb @(0x400000),d0
":::"d0");

#define SAFETY_HEIGHT 10
#define SAFETY_WIDTH 4
/* Offset rows down by 2 to deal with references before
   the start of the buffer */
#define FRAME_GET(fb,r,c) ((fb)->buff[(r+2)*((fb)->width + SAFETY_WIDTH) + (c)])

#define HSYNC_GRAB_DET() \
	 asm volatile("hsync_det: moveb 16775697,d0; btst #3,d0; jne hsync_det;	nop; nop; nop; nop; nop; movel _lutptr,d0;":::"d0")

static inline int get_frame1(Frame1 *fb,int row,int col) 
{
  int lw=fb->lwidth;
  int shift=col%32;
  int lcol=col/32;

  if(row>fb->height || col>fb->width)
    return(-1);
  else
    return(((fb->buff[row*lw+lcol])>>shift)&1);
}
static inline int put_frame1(Frame1 *fb,int row,int col,int val) 
{
  int lw=fb->lwidth;
  int shift=col%32;
  int lcol=col/32;
  uint *iptr;

  if(row>fb->height || col>fb->width)
    return(-1);

  iptr = &(fb->buff[row*lw+lcol]);

  if(val)
    {
      *iptr=(*iptr | (1<<shift));
    }
  else
    {
      *iptr=(*iptr & ~(1<<shift));
    }
  return(1);
}
  
#include "frame.pro"

#endif
