/***************************************************************************
	This source code is part of the Cognachrome 2000 vision system.
	Copyright 1994, Anne Wright, anarch@mit.edu,
	                Randy Sargent, rsargent@mit.edu
	This copy is not to be distributed in any form
	and is to be used only with express permission of the author.
****************************************************************************/

#ifndef __lut__
#define __lut__

#define LUTSIZE 0x10000

#define GET_LUT(i,rb,g) (((volatile byte *)lut_base)[LUTSIZE*i+(g)*256+(rb)])
#define SET_LUT(i,rb,g,val) ((((volatile byte *)lut_base)[LUTSIZE*i+(g)*256+(rb)])=(val))

#define GET_LUTRED(r,g) (GET_LUT(1,r,g))
#define SET_LUTRED(r,g,val) (SET_LUT(1,r,g,val))
#define GET_LUTBLUE(b,g) (GET_LUT(0,b,g))
#define SET_LUTBLUE(b,g,val) (SET_LUT(0,b,g,val))

extern volatile byte * const lutptr;
extern volatile byte * const lutblue;
extern volatile byte * const lutred;

#include "lut.pro"
#endif
